/**
 * Copyright 1998-2007, CHISEL Group, University of Victoria, Victoria, BC, Canada.
 * All rights reserved.
 */
package ca.uvic.csr.shrimp.jambalaya;

import java.awt.Component;

import edu.stanford.smi.protegex.owl.model.OWLHasValue;
import edu.stanford.smi.protegex.owl.model.OWLQuantifierRestriction;
import edu.stanford.smi.protegex.owl.model.RDFIndividual;
import edu.stanford.smi.protegex.owl.model.RDFResource;
import edu.stanford.smi.protegex.owl.model.RDFSNamedClass;

/**
 * @author Rob Lintern
 * @author Chris Callendar
 */
public class NeighbourhoodResourceAction extends ShowInQueryViewResourceAction {

    public NeighbourhoodResourceAction() {
        super(new NeighbourhoodAction("Show Neighbourhood (Jambalaya)..."), "Jambalaya", false, 
        		"Show how this resource relates to all others...");
    }

    /*
     * (non-Javadoc)
     * 
     * @see edu.stanford.smi.protegex.owl.ui.actions.ResourceAction#isSuitable(java.awt.Component,
     *      edu.stanford.smi.protegex.owl.model.RDFResource)
     */
    public boolean isSuitable(Component component, RDFResource resource) {
        if (resource instanceof OWLHasValue) {
            OWLHasValue hr = (OWLHasValue) resource;
            Object hasValue = hr.getHasValue();
            if (hasValue != null && (hasValue instanceof RDFSNamedClass || hasValue instanceof RDFIndividual)) {
                return true;
            }
        } else if (resource instanceof OWLQuantifierRestriction) {
            OWLQuantifierRestriction qr = (OWLQuantifierRestriction) resource;
            if (qr.getFiller() instanceof RDFSNamedClass) {
                RDFSNamedClass quantCls = (RDFSNamedClass) qr.getFiller();
                if (quantCls != null) {
                    return true;
                }
            }
        } else if (resource instanceof RDFSNamedClass || resource instanceof RDFIndividual) {
            return true;
        }
        return false;
    }

}
