var svgSVGElement;
var ZOOM_FACTOR_IN = 1.10;
var ZOOM_FACTOR_OUT = 1.0/ZOOM_FACTOR_IN;
var ZOOM_DIRECTION_IN = "in"
var ZOOM_DIRECTION_OUT = "out"
var ZOOM_KEY_IN = "Z"
var ZOOM_KEY_OUT = "X"
var ZOOM_TIMEOUT = 50; // milliseconds
var zoomFactor;
var zoomDirection;
var zooming = false;
var mouseLocX = 0.0;
var mouseLocY = 0.0;
var ABSOLUTE_ARC_WIDTH = 2.0;

var newScale = 1.0;
var newTransX = 0.0;
var newTransY = 0.0;


function dumpProps(obj, parent) {
   for (var i in obj) {
      if (parent) { msg = parent + "." + i + "\n" + obj[i]; } else { var msg = i + "\n" + obj[i]; }
      if (!confirm(msg)) { return; }
      if (typeof obj[i] == "object") { 
         if (parent) { dumpProps(obj[i], parent + "." + i); } else { dumpProps(obj[i], i); }
      }
   }
}

function LoadHandler (evt) { 
	if ( window.svgDocument == null ) {
		svgDocument = evt.target.ownerDocument;
	}
	svgSVGElement = svgDocument.getDocumentElement();
	new Title (svgDocument, 12); 
	var currentScale = svgDocument.getElementById("currentScale");
	var cscale = currentScale.getFirstChild().getNodeValue();

	//alert("displaybean scale "+cscale);

	var svgscale = svgSVGElement.getCurrentScale();
	//alert("svg startup scale "+svgscale);

	adjustArcWidths(cscale);

// 	setTimeout('adjustArcWidths(cscale)', 10);
	
 }
 
 function zoomHandler(evt) {
 	Title_Zoom(evt);	
	var cscale = svgSVGElement.getCurrentScale();
	//alert("zooming...true svg scale: "+ cscale);
	adjustArcWidths(cscale);
// 	setTimeout("adjustArcWidths(csale)", 100);
	//setTimeout('adjustCommentBox()', 100);
 }
 
 // update the thickness of the arcs so that they always appear the 
 // same thickness no matter what the current scale is 
 function adjustArcWidths (cs) {
	//alert("pass in scale " + cs);

 	// look for line elements
	var lineElements = svgDocument.getElementsByTagName ("line");
//	var cs = svgSVGElement.getCurrentScale();
	if((cs<=1)){
	   return;
	}
	if(cs>=2){
	   cs = cs*2;	
	}
	var newStrokeWidth = ABSOLUTE_ARC_WIDTH/cs;
	for (var i = 0; i<lineElements.getLength(); i++) {
		var lineElement = lineElements.item(i);
		var strokeWidth = lineElement.getAttribute ("stroke-width");
		// do not let stroke too thick 
		if(newStrokeWidth>=0.4){
		  newStrokeWidth = 0.1;
		}
		if(newStrokeWidth<=0.1){
		  newStrokeWidth = 0.2;
		}
		
	   lineElement.setAttribute ("stroke-width", "" + newStrokeWidth);
	}
//   	alert("draw stroke width: " + newStrokeWidth);

 }
 
 
 function adjustCommentBox () {
	var commentTransElement = svgDocument.getElementById ("commentTranslate");
	var commentScaleElement = svgDocument.getElementById ("commentScale");
  	var currSVGScale = svgSVGElement.currentScale;
	var newCommentScale = 1.0/currSVGScale;
	var currSVGTransX = svgSVGElement.currentTranslate.x
	var currSVGTransY = svgSVGElement.currentTranslate.y
	var newCommentTransX =  - currSVGTransX;
	var newCommentTransY =  - currSVGTransY;
	commentScaleElement.setAttribute("transform", "scale(" + newCommentScale + ")");
	commentTransElement.setAttribute("transform", "translate(" + newCommentTransX + "," + newCommentTransY + ")");
 }
 

 
function keyupHandler (keyEvent) {
	// Get the character-code of the key that was pressed.
	var key = keyEvent.keyCode;
	// Get string equivalent of input character-code.
	var input_text = String.fromCharCode(key);

	//window.status = input_text + "up";

	if (zooming && zoomDirection == ZOOM_DIRECTION_IN && input_text == ZOOM_KEY_IN) {
  		// zoom in
  		zooming = false;
	} else if (zooming && zoomDirection == ZOOM_DIRECTION_OUT && input_text == ZOOM_KEY_OUT) {
		// zoom out
  		zooming = false;
	} else {
		// do nothing
	}

}

function keydownHandler (keyEvent) {
	// Get the character-code of the key that was pressed.
	var key = keyEvent.keyCode;
	// Get string equivalent of input character-code.
	var input_text = String.fromCharCode(key);

	//window.status = input_text + "down";

	if (input_text == ZOOM_KEY_IN) {
  		// start zooming in
  		zoomDirection = ZOOM_DIRECTION_IN;
  		zoomFactor = ZOOM_FACTOR_IN;
  		zooming = true;

	} else if (input_text == ZOOM_KEY_OUT) {
		// start zooming out
		zoomDirection = ZOOM_DIRECTION_OUT
  		zoomFactor = ZOOM_FACTOR_OUT;
  		zooming = true;
	} else {
		zooming = false;
	}

	// keep zooming until a keyup event is thrown
	//if (zooming) {
		//setTimeout('zoomOneStep()', ZOOM_TIMEOUT);
	//}
	zoomOneStep();
}


function mousemoveHandler (evt) {
	
	mouseLocX = evt.getClientX();
	mouseLocY = evt.getClientY();
	var currScale = svgSVGElement.currentScale;
	var currTransX = svgSVGElement.currentTranslate.x;
	var currTransY = svgSVGElement.currentTranslate.y;
	var absoluteX = (mouseLocX - currTransX) / currScale;
	var absoluteY = (mouseLocY - currTransY) / currScale;

	var scaleAndTransform = "scale: " +  svgSVGElement.currentScale + "  translate: " + svgSVGElement.currentTranslate.x + "," + svgSVGElement.currentTranslate.y;
	var mouseLocationTransformed = "mouseLocation (transformed): " + mouseLocX + "," + mouseLocY;
	var mouseLocationAbsolute = "mouseLocation (absolute): " + absoluteX + "," + absoluteY;
	//window.status = scaleAndTransform + "  -  " + mouseLocationTransformed + "  -  " + mouseLocationAbsolute;
	Title.Activate(evt);
}

function zoomOneStep () {
  	var oldScale = svgSVGElement.currentScale;
  	var oldTransX = svgSVGElement.currentTranslate.x
  	var oldTransY = svgSVGElement.currentTranslate.y
  	newScale = oldScale;
 	newTransX = oldTransX;
 	newTransY = oldTransY;
 	var oldAbsoluteX = (mouseLocX - oldTransX) / oldScale;
	var oldAbsoluteY = (mouseLocY - oldTransY) / oldScale;

  	newScale = oldScale * zoomFactor;

	// we want the absolute point under the mouse to stay in the same place
	//ie. the absolute position of the mouse should be the same when done
	newTransX = mouseLocX - newScale * oldAbsoluteX;
	newTransY = mouseLocY - newScale * oldAbsoluteY;
	
	// set the new scale and translation
  	svgSVGElement.currentScale = newScale;
	svgSVGElement.currentTranslate.x = newTransX;
  	svgSVGElement.currentTranslate.y = newTransY;
}






























// == Title.js -- Copyright (C) Stefan Goessner ========================

function Title(doc, sz) {
   this.element = null;  // element to show title of ..
   Title.size = sz;      // text size ..
   Title.oldScale = document.getDocumentElement().getCurrentScale();     // scaling modified by zooming ..

   this.Create(doc);
   AddTitleEvents(doc.getDocumentElement());
   window.svgTitle = this;
}


Title.prototype.Create = function(doc){
   this.rec = doc.createElement("rect");
   this.rec.setAttribute("y", -0.9*Title.size);
   this.rec.setAttribute("x", -0.25*Title.size);
   this.rec.setAttribute("width", "1");
   this.rec.setAttribute("height", 1.25*Title.size);
   this.rec.setAttribute("style", "stroke:black;fill:#edefc2;stroke-width:1");

   this.str = doc.createTextNode("");

   this.txt = doc.createElement("text")
   this.txt.setAttribute("style", "font-family:Arial; font-size:" + Title.size + ";fill:black;");
   this.txt.appendChild(this.str);

   this.grp = doc.createElement("g"),
   this.grp.setAttribute("transform", "translate(0,0)");
   this.grp.setAttribute("visibility", "hidden");
   this.grp.appendChild(this.rec);
   this.grp.appendChild(this.txt);

   doc.getDocumentElement().appendChild(this.grp);
}


Title.Activate = function Title_Activate(evt) {
	mouseLocX = evt.getClientX();
	mouseLocY = evt.getClientY();
	
	var currScale = svgSVGElement.currentScale;
	var currTransX = svgSVGElement.currentTranslate.x;
	var currTransY = svgSVGElement.currentTranslate.y;
	var absoluteX = (mouseLocX - currTransX) / currScale;
	var absoluteY = (mouseLocY - currTransY) / currScale;
	
	var scaleAndTransform = "scale: " +  svgSVGElement.currentScale + "  translate: " + svgSVGElement.currentTranslate.x + "," + svgSVGElement.currentTranslate.y;
	var mouseLocationTransformed = "mouseLocation (transformed): " + mouseLocX + "," + mouseLocY;
	var mouseLocationAbsolute = "mouseLocation (absolute): " + absoluteX + "," + absoluteY;

	var x = (evt.getClientX() - document.getDocumentElement().getCurrentTranslate().getX())/document.getDocumentElement().getCurrentScale() +  0.25*Title.size;	
    var y = (evt.getClientY() - document.getDocumentElement().getCurrentTranslate().getY())/document.getDocumentElement().getCurrentScale() - Title.size;

	window.svgTitle.element = evt.getCurrentTarget();
	window.svgTitle.str.setNodeValue(TextOf(TitleElementOf(window.svgTitle.element)));
	window.svgTitle.rec.setAttribute("width", window.svgTitle.txt.getComputedTextLength() + 0.5*Title.size);
	window.svgTitle.grp.setAttribute("transform", "translate(" + x + "," + y + ")");
	window.svgTitle.grp.setAttribute("visibility", "visible");
}


Title.Zoom = function Title_Zoom(evt) {
   var newscl = evt.getTarget().getOwnerDocument().getDocumentElement().getCurrentScale();

   Title.size *= Title.oldScale/newscl;
   //alert ("Title.size: " + Title.size);
   Title.oldScale = newscl;

   window.svgTitle.rec.setAttribute("y", -0.9*Title.size);
   window.svgTitle.rec.setAttribute("x", -0.25*Title.size);
   window.svgTitle.rec.setAttribute("height", 1.25*Title.size);
   window.svgTitle.rec.setAttribute("style", "stroke:black;fill:#edefc2;stroke-width:" + 1/document.getDocumentElement().getCurrentScale());
   window.svgTitle.txt.setAttribute("style", "font-family:Arial; font-size:" + Title.size + ";fill:black;");
}


Title.Register = function Title_Register(elem) {
   if (TitleElementOf(elem) != null)
      elem.addEventListener("mousemove", Title.Activate, false);
}


// --- local helper functions ------------------------

function TitleElementOf(elem) {
   var childs = elem.getChildNodes();

   for (var i=0; i<childs.getLength(); i++)
      if (childs.item(i).getNodeType() == 1 && childs.item(i).getNodeName() == "title") // title element ..
         return childs.item(i);
   
   return null;
}

function TextOf(elem) {
   var childs = elem ? elem.getChildNodes() : null;

   for (var i=0; childs && i<childs.getLength(); i++)
      if (childs.item(i).getNodeType() == 3) // text node ..
         return childs.item(i).getNodeValue();
   
   return "";
}

function AddTitleEvents(elem) {
   var childs = elem.getChildNodes();

   for (var i=0; i<childs.getLength(); i++)
      if (childs.item(i).getNodeType() == 1) // element node ..
         AddTitleEvents(childs.item(i));

   if (TitleElementOf(elem) != null)
      elem.addEventListener("mousemove", Title.Activate, false);
}

// === end ======================================================